package com.usky.system.service.util;

import cn.hutool.http.HttpUtil;
import com.ruoyi.common.core.utils.ip.IpUtils;
import com.usky.system.domain.WjConfig;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.StringUtils;

/**
 * 获取地址类
 *
 * @author xy
 */
public class AddressUtils {
    private static final Logger log = LoggerFactory.getLogger(AddressUtils.class);

    // IP地址查询
    public static  String IP_URL = "http://whois.pconline.com.cn/ip.jsp?ip=";

    // 未知地址
    public static final String UNKNOWN = "未知地址";

    public static String getRealAddressByIP(String ip) {
        // 内网不查询
        if (IpUtils.internalIp(ip)) {
            return "内网IP";
        }
        if (WjConfig.isAddressEnabled()) {
            try {
                String url = IP_URL + ip;
                String rspStr = HttpUtil.get(url);
                log.info("ip is {}, repStr is {}, url is {}", ip, rspStr, url);
                if (StringUtils.isEmpty(rspStr.trim())) {
                    log.error("获取地理位置异常 {}, {}", ip, rspStr);
                    return UNKNOWN;
                }
                return rspStr.trim();
            } catch (Exception e) {
                log.error("获取地理位置异常 {}", ip);
            }
        }
        return UNKNOWN;
    }
}
